/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3910_CDPSTP0.SQL

Descrio:
Gera os produtos para a tela MRP.

P_CDFILIAL     - Cdigo da Filial a ser gerado o MRP.
P_DTMRP        - Data da Gerao do MRP.
P_IDPRODVENACA - Identificador de Produto de Venda ou Produto Semi Acabado.
P_CDPRODUTO    - Cdigo do Produto pedido.
P_IDPRODPROD   - Identificador se o produto  produto de produo
P_QTVENDAPCP   - Quantidade de venda.
P_DTINI        - Data Inicial.
P_DTFIN        - Data Final.
P_IDMRPPEDPREV - Identificador da gerao do MRP para Pedidos e/ou
                 para Previso de Vendas.
P_IDESTOQUE    - Identificador (considera ou no estoque).
P_IDCONSDEMA   - Identificador (considera ou no demanda extra).

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
15/09/2004 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'GERA_MRP_PRODUTO'  and
            type   = 'P'                 and
            u.uid  = o.uid               and
            u.name = USER)
  DROP PROCEDURE GERA_MRP_PRODUTO
  GO

CREATE PROCEDURE GERA_MRP_PRODUTO
    @P_QTANDPROD      DOUBLE PRECISION,
    @P_QTTOTALPROD    DOUBLE PRECISION,
    @P_IDSEMIACETAP   VARCHAR(1) = 'N',
    @P_CDFILIAL      VARCHAR(4),
    @P_DTMRP         DATETIME,
    @P_CDPRODUTO     VARCHAR(10),
    @P_IDPRODPROD    VARCHAR(1),
    @P_DTENTPROD     DATETIME,
    @P_QTESTQINI     DOUBLE PRECISION,
    @P_QTESTOQMIN    DOUBLE PRECISION,
    @P_QTPADPROCFAB  DOUBLE PRECISION,
    @P_QTLOTEFABPCP  DOUBLE PRECISION,
    @P_QTVENDAPCP    DOUBLE PRECISION,
    @P_QTEMPRODUCAO  DOUBLE PRECISION,
    @P_DTINI         DATETIME,
    @P_DTFIN         DATETIME,
    @P_CDPRODINIPCP  VARCHAR(20),
    @P_CDPRODFINPCP  VARCHAR(20),
    @P_IDMRPPEDPREV  VARCHAR(1),
    @P_IDESTOQUE     VARCHAR(1),
    @P_IDCONSDEMA    VARCHAR(1),
    @P_NRORDENAOP    DOUBLE PRECISION,
    @P_NRORDENASUBOP VARCHAR(1),
    @P_DTENTPRODACAB DATETIME,
    @P_CDPRODFINAL    VARCHAR(10)= '',
    @P_NRORDEMPROD   DOUBLE PRECISION,
    @P_IDSUBOPINSU   VARCHAR(1) = 'N'
AS
   DECLARE @V_CDPRODPROD    VARCHAR(10);
   DECLARE @V_VRFATOCONVPR  DOUBLE PRECISION;
BEGIN
   SELECT
      @V_CDPRODPROD   = MAX(CDPRODPROD),
      @V_VRFATOCONVPR = MAX(VRFATOCONVPR)
   FROM
      PRODUTO
   WHERE
      (CDPRODUTO = @P_CDPRODUTO);
END;
GO

ALTER PROCEDURE GERA_MRP_PRODUTO
    @P_QTANDPROD      DOUBLE PRECISION,
    @P_QTTOTALPROD    DOUBLE PRECISION,
    @P_IDSEMIACETAP   VARCHAR(1) = 'N',
    @P_CDFILIAL      VARCHAR(4),
    @P_DTMRP         DATETIME,
    @P_CDPRODUTO     VARCHAR(10),
    @P_IDPRODPROD    VARCHAR(1),
    @P_DTENTPROD     DATETIME,
    @P_QTESTQINI     DOUBLE PRECISION,
    @P_QTESTOQMIN    DOUBLE PRECISION,
    @P_QTPADPROCFAB  DOUBLE PRECISION,
    @P_QTLOTEFABPCP  DOUBLE PRECISION,
    @P_QTVENDAPCP    DOUBLE PRECISION,
    @P_QTEMPRODUCAO  DOUBLE PRECISION,
    @P_DTINI         DATETIME,
    @P_DTFIN         DATETIME,
    @P_CDPRODINIPCP  VARCHAR(20),
    @P_CDPRODFINPCP  VARCHAR(20),
    @P_IDMRPPEDPREV  VARCHAR(1),
    @P_IDESTOQUE     VARCHAR(1),
    @P_IDCONSDEMA    VARCHAR(1),
    @P_NRORDENAOP    VARCHAR(10),
    @P_NRORDENASUBOP VARCHAR(1),
    @P_DTENTPRODACAB DATETIME,
    @P_CDPRODFINAL    VARCHAR(10)= '',
    @P_NRORDEMPROD   DOUBLE PRECISION,
    @P_IDSUBOPINSU   VARCHAR(1) = 'N'

AS
   DECLARE @V_CDPRODPROD    VARCHAR(10);
   DECLARE @V_VRFATOCONVPR  DOUBLE PRECISION;
   DECLARE @V_CDPRODMRP     VARCHAR(10);
   DECLARE @V_QTEMPRODUPCP  DOUBLE PRECISION;
   DECLARE @V_QTESTQINI     DOUBLE PRECISION;
   DECLARE @V_QTESTOQMIN    DOUBLE PRECISION;
   DECLARE @V_QTPADPROCFAB  DOUBLE PRECISION;
   DECLARE @V_QTLOTEFABPCP  DOUBLE PRECISION;
   DECLARE @V_CDPRODUTO     VARCHAR(10);
   DECLARE @V_QTESTOQUEPCP  DOUBLE PRECISION;
   DECLARE @V_QTAFABRICPCP  DOUBLE PRECISION;
   DECLARE @V_QTVENDAPCP    DOUBLE PRECISION;
   DECLARE @V_QTVENDADATA   DOUBLE PRECISION;
   DECLARE @V_QTESTANT      DOUBLE PRECISION;
   DECLARE @V_QTHORASPROD   INT;
   DECLARE @V_DTENTSEMIAC   DATETIME;
   DECLARE @V_TESTE         VARCHAR(10);


   DECLARE @C_SEMIACABADO_CDPRODINSUMO      varchar(10);
   DECLARE @C_SEMIACABADO_IDSUBOPINSU       char(1);
   DECLARE @C_SEMIACABADO_NRORDENAOP        varchar(10);
   DECLARE @C_SEMIACABADO_NRORDENASUBOP     varchar(1);
   DECLARE @C_SEMIACABADO_IDPRODPROD        varchar(1);
   DECLARE @C_SEMIACABADO_QTESTOQMIN        double precision;
   DECLARE @C_SEMIACABADO_QTPRODUCAO        double precision;
   DECLARE @C_SEMIACABADO_QTDEESTO          double precision;
   DECLARE @C_SEMIACABADO_QTPADPROCFAB      double precision;
   DECLARE @C_SEMIACABADO_QTLOTEFABDIA      double precision;
   DECLARE @C_SEMIACABADO_DTCONCPROMRP      datetime;
   DECLARE @C_SEMIACABADO_QUANTIDADE        double precision;
   DECLARE @C_SEMIACABADO_QTSEMITOTAL       double precision;
   DECLARE @C_SEMIACABADO_IDSEMIACETAP      varchar(1);
   DECLARE @C_SEMIACABADO_CDPROCFABRIC      varchar(10)    

   DECLARE @V_NRORDENAOP                 VARCHAR(10);
   DECLARE @V_NRORDENASUBOP              VARCHAR(1);
   DECLARE @V_IDGERAOPCONF VARCHAR(1);
   DECLARE @V_QTRECPROGR                 FLOAT;
   DECLARE @V_DTENTPROD                  DATETIME;
   DECLARE @V_QTAPRODPREOPDIA            FLOAT;
   DECLARE @V_PRODUTOOP                  VARCHAR(10);
   DECLARE @V_ESTRESRANTE                FLOAT;

   DECLARE @V_CURSORSACAB   CURSOR;
   DECLARE @V_NRORDEMPROD DOUBLE PRECISION;
BEGIN

   SET @V_NRORDENAOP    = @P_NRORDENAOP;
   SET @V_NRORDENASUBOP = @P_NRORDENASUBOP;

   IF NOT @P_IDPRODPROD = 'S' BEGIN
      SELECT
         @V_CDPRODPROD = MAX(CDPRODPROD),
         @V_VRFATOCONVPR= MAX(VRFATOCONVPR)
      FROM
         PRODUTO
      WHERE
         (CDPRODUTO = @P_CDPRODUTO);

      IF NOT @V_CDPRODPROD IS NULL BEGIN
         SET @V_CDPRODMRP = @V_CDPRODPROD;

         SELECT
            @V_QTEMPRODUPCP = SUM(A.QTPRODUCAO)
         FROM
            (SELECT/*ALTERAR*/
                ISNULL(SUM(L.QTPRODLOTE), 0) AS QTPRODUCAO
             FROM
                LOTE L, PARAMPRODMRP P
             WHERE
                (L.CDFILIAL     = @P_CDFILIAL)  AND
                (L.CDPRODUTO    = @V_CDPRODMRP) AND
                (L.IDSTPRODLOTE = '3') AND
                (P.CDFILIAL = L.CDFILIAL) AND
                (P.CDPRODUTO = L.CDPRODUTO)AND
                (P.IDGERAOPCONF = 'S')

             UNION ALL
             SELECT
                ISNULL(SUM(QTAPRODPREOP),0) AS QTPRODUCAO
             FROM
                ORDPRODUCAO O, PARAMPRODMRP P
             WHERE
                (O.CDFILIAL     = @P_CDFILIAL)  AND
                (O.CDPRODUTO    = @V_CDPRODMRP) AND
                (O.IDSITORDPROD = '1')         AND
                (O.IDCONFIRMAOP = 'S')         AND
                (P.CDFILIAL = O.CDFILIAL  )    AND
                (P.CDPRODUTO = O.CDPRODUTO)    AND
                (P.IDGERAOPCONF = 'S')
            ) A;

         SELECT
            @V_QTPADPROCFAB = MAX(QTPADPROCFAB),
            @V_QTLOTEFABPCP = MAX(QTLOTEFABDIA)
         FROM
            PROCFABRICA
         WHERE
            CDFILIAL     = @P_CDFILIAL  AND
            CDPRODUTO    = @V_CDPRODMRP AND
            IDPROFABPADR = 'S';
         IF @V_VRFATOCONVPR > 0 BEGIN
            SET @V_QTEMPRODUPCP = (@V_QTEMPRODUPCP / @V_VRFATOCONVPR);
         END;
      END;
   END
   ELSE BEGIN
      SET @V_CDPRODMRP    = @P_CDPRODUTO;
      SET @V_VRFATOCONVPR = 1;
      SET @V_QTEMPRODUPCP = @P_QTEMPRODUCAO;
      SET @V_QTPADPROCFAB = @P_QTPADPROCFAB;
      SET @V_QTLOTEFABPCP = @P_QTLOTEFABPCP;
   END;

/* VERIFICA SE O PRODUTO CONSIDERA QUANTIDADE EM PRODUCAO */

   SELECT @V_IDGERAOPCONF = IDGERAOPCONF
     FROM PARAMPRODMRP
    WHERE
       CDFILIAL  = @P_CDFILIAL AND
       CDPRODUTO = @V_CDPRODMRP;


   IF @V_IDGERAOPCONF IS NULL BEGIN
      SET @V_IDGERAOPCONF = 'N';
   END;

   IF NOT @V_CDPRODMRP IS NULL BEGIN
      SET @V_QTESTOQMIN = @P_QTESTOQMIN;
 /*VERIFICA SE O PRODUTO J EXISTE NA PROGRAMAO DO DIA */
      SELECT
         @V_CDPRODUTO = MAX(CDPRODUTO),
         @V_QTVENDADATA = MAX(QTVENDAPCP)
      FROM
         PROGPRODU
      WHERE
         (CDFILIAL    = @P_CDFILIAL)     AND
         (DTPROGPRODU = @P_DTMRP)        AND
         (CDPRODUTO   = @V_CDPRODMRP)    AND
         (CONVERT( DATETIME, DTENTPROD, 103) = CONVERT( DATETIME, @P_DTENTPROD ,103));

/*CASO AINDA NO EXISTA */
      IF @V_CDPRODUTO IS NULL BEGIN
/*VERIFICA SE O PRODUTO EXISTE EM OUTRO DIA PARA FAZER O ESTOQUE PROJETADO E ATUALIZAR A INFORMAO DE ESTOQUE DIA DO PRODUTO */
         SELECT
            @V_CDPRODUTO = MAX(CDPRODUTO)
         FROM
            PROGPRODU
         WHERE
            (CDFILIAL    = @P_CDFILIAL)   AND
            (DTPROGPRODU = @P_DTMRP)      AND
            (CDPRODUTO   = @V_CDPRODMRP);

/*total de ops em andamento para o dia*/
         SELECT 
            @V_QTAPRODPREOPDIA = ISNULL(SUM(OP.QTAPRODPREOP), 0)
         FROM
            ORDPRODUCAO OP, PARAMPRODMRP P
         WHERE
            (OP.CDFILIAL     = @P_CDFILIAL)  AND
            (OP.CDPRODUTO    = @P_CDPRODUTO) AND
            (CONVERT(VARCHAR, OP.DTHRFIMPREOP, 103) = CONVERT(VARCHAR, @P_DTENTPROD, 103)) AND
            (OP.IDSITORDPROD = '2')AND
            P.CDFILIAL = OP.CDFILIAL AND
            P.CDPRODUTO = OP.CDPRODUTO AND
            P.IDGERAOPCONF = 'S';

       
         IF @V_CDPRODUTO IS NULL BEGIN
            IF (@V_IDGERAOPCONF = 'N')BEGIN
               SET @V_QTESTOQUEPCP = (@P_QTESTQINI + @V_QTEMPRODUPCP) - @P_QTVENDAPCP;
            END
            ELSE BEGIN
               SET @V_QTESTOQUEPCP = (@P_QTESTQINI + @V_QTEMPRODUPCP + @V_QTAPRODPREOPDIA) - @P_QTVENDAPCP;
            END;
  
            IF @V_QTESTOQUEPCP < 0 BEGIN
/* O SISTEMA UTILIZOU TOTALMENTE O ESTOQUE ATUAL */
               SET @V_QTAFABRICPCP = ABS(@V_QTESTOQUEPCP) + @V_QTESTOQMIN;
               SET @V_QTESTOQUEPCP = @V_QTESTOQMIN;

            END
            ELSE BEGIN
               IF @V_QTESTOQUEPCP < @V_QTESTOQMIN BEGIN
                  SET @V_QTAFABRICPCP = @V_QTESTOQMIN - @V_QTESTOQUEPCP;
                  SET @V_QTESTOQUEPCP = @V_QTESTOQMIN;
               END
               ELSE BEGIN
/* No deve produzir mas deve subtrair do estoque projetado */
                  SET @V_QTAFABRICPCP = 0;
               END;
            END;
         END
         ELSE BEGIN
            SELECT
               @V_QTESTOQUEPCP = MAX(P.QTESTOQUEPCP)
            FROM
               (SELECT
                   MAX(DTENTPROD) AS DTENTPROD
                FROM
                   PROGPRODU
                WHERE
                   CDFILIAL    = @P_CDFILIAL   AND
                   DTPROGPRODU = @P_DTMRP      AND
                   CDPRODUTO   = @V_CDPRODMRP
               ) A,
               PROGPRODU P
            WHERE
               P.CDFILIAL    = @P_CDFILIAL   AND
               P.DTPROGPRODU = @P_DTMRP      AND
               P.CDPRODUTO   = @V_CDPRODMRP  AND
               P.DTENTPROD   = A.DTENTPROD;
  
            /* Estoque calculado*/
            IF (@V_IDGERAOPCONF = 'S')BEGIN
               SET @V_QTESTOQUEPCP = (@V_QTESTOQUEPCP + @V_QTAPRODPREOPDIA) - @P_QTVENDAPCP;
            END
            ELSE BEGIN
               SET @V_QTESTOQUEPCP = @V_QTESTOQUEPCP - @P_QTVENDAPCP;
            END;

            IF @V_QTESTOQUEPCP < 0 BEGIN
               SET @V_QTAFABRICPCP = ABS(@V_QTESTOQUEPCP) + @V_QTESTOQMIN;
               SET @V_QTESTOQUEPCP = @V_QTESTOQMIN;
            END
            ELSE BEGIN
               IF @V_QTESTOQUEPCP < @V_QTESTOQMIN BEGIN
                  SET @V_QTAFABRICPCP = @V_QTESTOQMIN - @V_QTESTOQUEPCP;
                  SET @V_QTESTOQUEPCP = @V_QTESTOQMIN;
               END
               ELSE BEGIN
                  SET @V_QTAFABRICPCP = 0;
               END;
            END;
         END;

/* CASO O PRODUTO CONSIDERE A QUANTIDADE EM PRODUO O ESTOQUE TAMBM SER CALCULADO */
         IF (@P_IDESTOQUE = 'S')OR(@V_IDGERAOPCONF = 'S')BEGIN
            SET @V_QTESTQINI = (@P_QTESTQINI * @V_VRFATOCONVPR);

            IF (@V_IDGERAOPCONF = 'S')BEGIN
               SET @V_QTESTQINI = @V_QTESTQINI +(@V_QTEMPRODUPCP * @V_VRFATOCONVPR);
            END;
  
            SET @V_QTESTOQUEPCP = (@V_QTESTOQUEPCP * @V_VRFATOCONVPR);
            SET @V_QTAFABRICPCP = (@V_QTAFABRICPCP * @V_VRFATOCONVPR);

         END
         ELSE BEGIN
            SET @V_QTESTQINI    = 0;
            SET @V_QTESTOQUEPCP = 0;
            SET @V_QTAFABRICPCP = (@P_QTVENDAPCP * @V_VRFATOCONVPR);
         END;

         /*se sobrou produto restante do estoque projetado do dia anterior*/
         IF @P_IDSEMIACETAP = 'S' BEGIN
               SELECT @V_ESTRESRANTE = QTESTOQUEPCP
                 FROM PROGPRODU
                WHERE CONVERT(DATETIME, DTENTPROD, 103) = CONVERT(DATETIME, @P_DTENTPROD, 103) - 1
                  AND CDPRODUTO = @P_CDPRODINIPCP
                  AND CDFILIAL = @P_CDFILIAL
                  AND dtprogprodu = (select max(dtprogprodu) from PROGPRODU);
            
            SET @V_QTESTOQUEPCP = @V_QTESTOQUEPCP + @V_ESTRESRANTE;
         END;

         SET @V_QTESTOQMIN   = (@V_QTESTOQMIN   * @V_VRFATOCONVPR);
         SET @V_QTVENDAPCP   = (@P_QTVENDAPCP   * @V_VRFATOCONVPR);
         SET @V_QTEMPRODUPCP = (@V_QTEMPRODUPCP * @V_VRFATOCONVPR);

         INSERT INTO PROGPRODU
           (CDFILIAL,     DTPROGPRODU,  CDPRODUTO,    DTENTPROD,   QTESTDIAPCP,
            QTESTMINPCP,  QTPADPRODPCP, QTLOTEFABPCP, QTVENDAPCP,  QTESTOQUEPCP, QTEMPRODUPCP,
            QTAFABRICPCP, DTPERINIPCP,  DTPERFINPCP, CDPRODINIPCP, CDPRODFINPCP, IDMRPPEDPREV, IDCONSDEMA, DTENTPRODACAB, IDESTOQUEMRP,  
            QTRECPROGR, QTTOTALPRODU)
         VALUES
           (@P_CDFILIAL,   @P_DTMRP,        @P_CDPRODUTO, CONVERT(DATETIME, @P_DTENTPROD, 103), @V_QTESTQINI,
            @V_QTESTOQMIN, @V_QTPADPROCFAB, @V_QTLOTEFABPCP, @V_QTVENDAPCP,   @V_QTESTOQUEPCP, @V_QTEMPRODUPCP,
            @V_QTAFABRICPCP, @P_DTINI,      @P_DTFIN,        @P_CDPRODINIPCP, @P_CDPRODFINPCP, @P_IDMRPPEDPREV, @P_IDCONSDEMA, @P_DTENTPRODACAB, @P_IDESTOQUE,
            @V_QTAPRODPREOPDIA, @P_QTTOTALPROD);
      END
      ELSE BEGIN
         SET @V_QTVENDAPCP = @V_QTVENDADATA + @P_QTVENDAPCP;

         /*Verifica a qtde. do estoque projetado da entrega anterior*/
/* O estoque deve ser calculado se o produto considera estoque produzido ou estoque em produo */
         IF(@P_IDESTOQUE = 'S')OR( @V_IDGERAOPCONF = 'S' )BEGIN
            SELECT
               @V_QTESTANT = MAX(P.QTESTOQUEPCP)
            FROM
               (SELECT
                   MAX(DTENTPROD) AS DTENTPROD
                FROM
                   PROGPRODU
                WHERE
                   CDFILIAL    = @P_CDFILIAL   AND
                   DTPROGPRODU = @P_DTMRP      AND
                   CDPRODUTO   = @V_CDPRODMRP  AND
                   CONVERT( DATETIME, DTENTPROD, 103) <= CONVERT( DATETIME, @P_DTENTPROD, 103)
               ) A,
               PROGPRODU P
            WHERE
               P.CDFILIAL    = @P_CDFILIAL   AND
               P.DTPROGPRODU = @P_DTMRP      AND
               P.CDPRODUTO   = @V_CDPRODMRP  AND
               P.DTENTPROD   = A.DTENTPROD;

            SET @V_QTESTOQUEPCP = ISNULL(@V_QTESTANT,0) - @P_QTVENDAPCP;

            IF @V_QTESTOQUEPCP <= 0 BEGIN
               SET @V_QTAFABRICPCP =  ABS(@V_QTESTOQUEPCP) + @P_QTESTOQMIN;
               SET @V_QTESTOQUEPCP = @V_QTESTOQMIN;
            END
            ELSE BEGIN
               IF @V_QTESTOQUEPCP >= @V_QTESTOQMIN BEGIN
                  SET @V_QTAFABRICPCP = 0;
               END
               ELSE BEGIN
                  SET @V_QTAFABRICPCP = @V_QTESTOQMIN - @V_QTESTOQUEPCP;
                  SET @V_QTESTOQUEPCP = @V_QTESTOQMIN;
               END;
            END;
         END
         ELSE BEGIN
            SET @V_QTESTOQUEPCP = 0;
            SET @V_QTAFABRICPCP = @P_QTVENDAPCP;
         END;

         UPDATE PROGPRODU
         SET
            QTVENDAPCP   = @V_QTVENDAPCP,
            QTESTOQUEPCP = @V_QTESTOQUEPCP,
            QTAFABRICPCP = QTAFABRICPCP + @V_QTAFABRICPCP
         WHERE
            (CDFILIAL    = @P_CDFILIAL)     AND
            (DTPROGPRODU = @P_DTMRP)        AND
            (CDPRODUTO   = @V_CDPRODMRP)    AND
            CONVERT(DATETIME, DTENTPROD, 103) = CONVERT( DATETIME, @P_DTENTPROD, 103)
      END;

      IF @V_QTAFABRICPCP > 0 BEGIN
          EXEC GERA_CALE_PRODU  @P_CDFILIAL, @P_DTMRP, @P_IDESTOQUE, @V_CDPRODMRP,  @P_DTENTPROD, @P_NRORDENAOP, @P_NRORDENASUBOP,
                                @P_IDSUBOPINSU, @P_CDPRODFINAL, @V_QTAFABRICPCP, @P_NRORDEMPROD, @P_QTESTQINI, @V_NRORDEMPROD;
      END;

      /* Verifica se possui Semi Acabado */
      IF @V_QTAFABRICPCP > 0 BEGIN

         EXEC CURSOR_SEMIACABADO @P_CDFILIAL, @V_CDPRODMRP, @P_DTMRP, @V_QTAFABRICPCP, @P_IDESTOQUE, @P_NRORDENAOP, @P_CURSOR_SACAB = @V_CURSORSACAB OUTPUT;

         FETCH NEXT FROM @V_CURSORSACAB INTO @C_SEMIACABADO_CDPRODINSUMO, @C_SEMIACABADO_IDSUBOPINSU,
                                             @C_SEMIACABADO_NRORDENAOP,   @C_SEMIACABADO_NRORDENASUBOP,
                                             @C_SEMIACABADO_IDPRODPROD,   @C_SEMIACABADO_QTESTOQMIN,
                                             @C_SEMIACABADO_QTPRODUCAO,   @C_SEMIACABADO_QTDEESTO,
                                             @C_SEMIACABADO_QTPADPROCFAB, @C_SEMIACABADO_QTLOTEFABDIA,
                                             @C_SEMIACABADO_DTCONCPROMRP, @C_SEMIACABADO_QTSEMITOTAL,
                                             @C_SEMIACABADO_IDSEMIACETAP, @C_SEMIACABADO_QUANTIDADE;


         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF NOT @C_SEMIACABADO_CDPRODINSUMO IS NULL BEGIN
               IF @C_SEMIACABADO_IDSUBOPINSU = 'S' BEGIN
                  SET @V_NRORDENASUBOP = CONVERT(CHAR, (CONVERT(NUMERIC, ISNULL(@C_SEMIACABADO_NRORDENASUBOP,'0')) + 1));
                  SET @V_NRORDENAOP    = @C_SEMIACABADO_NRORDENAOP;
               END
               ELSE BEGIN
                  SELECT @V_NRORDENAOP = RIGHT(REPLICATE('0',10)+RTRIM(CONVERT(CHAR, CONVERT(NUMERIC, ISNULL(MAX(NRORDENAOP),'0')) + 1)),10)
                  FROM CALEPRODMRP
                  WHERE CDFILIAL = @P_CDFILIAL
                    AND DTPROGPRODCP = @P_DTMRP;

                  SET @V_NRORDENASUBOP = '0';
               END;

               EXEC GERA_MRP_PRODUTO 0, @C_SEMIACABADO_QTSEMITOTAL, @C_SEMIACABADO_IDSEMIACETAP, @P_CDFILIAL, @P_DTMRP, @C_SEMIACABADO_CDPRODINSUMO, @C_SEMIACABADO_IDPRODPROD,
                                     @C_SEMIACABADO_DTCONCPROMRP, @C_SEMIACABADO_QTDEESTO, @C_SEMIACABADO_QTESTOQMIN, @C_SEMIACABADO_QTPADPROCFAB,
                                     @C_SEMIACABADO_QTLOTEFABDIA, @C_SEMIACABADO_QUANTIDADE, @C_SEMIACABADO_QTPRODUCAO,
                                     @P_DTINI, @P_DTFIN,  @P_CDPRODINIPCP, @P_CDPRODFINPCP, @P_IDMRPPEDPREV, @P_IDESTOQUE, @P_IDCONSDEMA,
                                     @V_NRORDENAOP, @V_NRORDENASUBOP, @P_DTENTPRODACAB, @V_NRORDEMPROD, @C_SEMIACABADO_IDSUBOPINSU, @P_CDPRODFINAL;


         FETCH NEXT FROM @V_CURSORSACAB INTO @C_SEMIACABADO_CDPRODINSUMO, @C_SEMIACABADO_IDSUBOPINSU,
                                             @C_SEMIACABADO_NRORDENAOP,   @C_SEMIACABADO_NRORDENASUBOP,
                                             @C_SEMIACABADO_IDPRODPROD,   @C_SEMIACABADO_QTESTOQMIN,
                                             @C_SEMIACABADO_QTPRODUCAO,   @C_SEMIACABADO_QTDEESTO,
                                             @C_SEMIACABADO_QTPADPROCFAB, @C_SEMIACABADO_QTLOTEFABDIA,
                                             @C_SEMIACABADO_DTCONCPROMRP, @C_SEMIACABADO_QTSEMITOTAL,
                                             @C_SEMIACABADO_IDSEMIACETAP, @C_SEMIACABADO_QUANTIDADE;
            END;
         END;
         CLOSE @V_CURSORSACAB;
         DEALLOCATE @V_CURSORSACAB;
      END;
   END;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_MRP_PRODUTO','5.05.016';
GO

